/*
16λģ飬ÿη16λ

*/
module my_uart_tx(clk,rst_n,clk_bps,rx_data,rx_int,rs232_tx,bps_start);
input 	clk;    				// 50MHzʱ
input 	rst_n;  				//͵ƽλź
input 	clk_bps;      		// clk_bpsĸߵƽΪջ߷λм
input	[15:0] rx_data;  	//ݼĴ
input 	rx_int;     			//жź,յڼʼΪߵƽ,ڴ½
output 	rs232_tx;  			// RS232ź
output 	bps_start; 			//ջҪݣʱźλ
//---------------------------------------------------------
reg rx_int0,rx_int1,rx_int2;    //rx_intźżĴ׽½˲
wire neg_rx_int;  // rx_int½ر־λ
always @ (posedge clk or negedge rst_n) begin
    if(!rst_n) begin
           rx_int0 <= 1'b0;
           rx_int1 <= 1'b0;
           rx_int2 <= 1'b0;
       end
    else begin
           rx_int0 <= rx_int;
           rx_int1 <= rx_int0;
           rx_int2 <= rx_int1;
       end
end
assign neg_rx_int =  ~rx_int1 & rx_int2;  //׽½غneg_rx_intرһʱ
//---------------------------------------------------------
reg[15:0] tx_data; //ݵļĴ
//---------------------------------------------------------
reg bps_start_r;
reg tx_en; //ʹźţЧ
reg[4:0] num;
always @ (posedge clk or negedge rst_n) begin
    if(!rst_n) begin
           bps_start_r <= 1'bz;
           tx_en <= 1'b0;
           tx_data <= 16'd0;
       end
    else if(neg_rx_int) begin   //ϣ׼ѽյݷȥ
           bps_start_r <= 1'b1;
           tx_data <= rx_data;  //ѽյݴ뷢ݼĴ
           tx_en <= 1'b1;       //뷢״̬
       end
    else if(num==5'd19) begin   //ݷɣλ
          bps_start_r <= 1'bz;
          tx_en <= 1'b0;
       end
end
assign bps_start = bps_start_r;

//---------------------------------------------------------
reg rs232_tx_r;
always @ (posedge clk or negedge rst_n) begin
    if(!rst_n) begin
           num <= 5'd0;
           rs232_tx_r <= 1'b1;
       end
    else if(tx_en) begin
           if(clk_bps)   begin
                  num <= num+1'b1;
                  case (num)
                     5'd0:   rs232_tx_r <= 1'b0; 			//ʼλ
                     5'd1:   rs232_tx_r <= tx_data[0];   	//bit0
                     5'd2:   rs232_tx_r <= tx_data[1];   	//bit1
                     5'd3:   rs232_tx_r <= tx_data[2]; 		//bit2
                     5'd4:   rs232_tx_r <= tx_data[3]; 		//bit3
                     5'd5:   rs232_tx_r <= tx_data[4]; 		//bit4
                     5'd6:   rs232_tx_r <= tx_data[5]; 		//bit5
                     5'd7:   rs232_tx_r <= tx_data[6];   	//bit6
                     5'd8:   rs232_tx_r <= tx_data[7]; 		//bit7
                     5'd9:   rs232_tx_r <= tx_data[8]; 		//bit8
                     5'd10:  rs232_tx_r <= tx_data[9]; 		//bit9
                     5'd11:  rs232_tx_r <= tx_data[10]; 	//bit10
                     5'd12:  rs232_tx_r <= tx_data[11]; 	//bit11
                     5'd13:  rs232_tx_r <= tx_data[12]; 	//bit12
                     5'd14:  rs232_tx_r <= tx_data[13]; 	//bit13
                     5'd15:  rs232_tx_r <= tx_data[14]; 	//bit14
                     5'd16:  rs232_tx_r <= tx_data[15]; 	//bit15
                     5'd17:  rs232_tx_r <= 1'b0;   			//ͽλ
                     default: rs232_tx_r <= 1'b1;
                     endcase
              end
           else if(num==5'd19) num <= 5'd0;   //λ
       end
end
assign rs232_tx = rs232_tx_r;
endmodule
